Fixpoint plus (n : nat) (m : nat) : nat :=
  match n with
    | O => m
    | S n' => S (plus n' m)
  end.

Theorem plus_n_O_firsttry : forall n:nat,
  n = n + 0.
Proof.
  intros n.
  simpl. (* Does nothing! *)
Abort.



Theorem plus_n_O_secondtry : forall n:nat,
  n = n + 0.
Proof.
  destruct n as [| n'] eqn:E.
  - (* n = 0 *)
    reflexivity. (* So far so good... *)
  - (* n = S n' *)
    simpl.       (* ...不过我们又卡在这儿了 *)
Abort.


Theorem plus_n_O : forall n : nat, n = n + 0.
Proof.
  intros n.
  induction n as [| n' IHn']. 
  - (* n = 0 *)
    reflexivity.
  - (* n = S n' *)
    simpl.
    rewrite <- IHn'. (* 应用归纳假设 *)
    reflexivity.
Qed.


(*证明 1+2+3+…+n = n(n+1)/2
(sum_to n) + (sum_to n) = n * (S n)
比2 * (sum_to n) = n * (n + 1)好
*)
Fixpoint sum_to (n : nat) : nat :=
  match n with
  | 0 => 0
  | S n' => S n' + sum_to n'
  end.



Theorem plus_assoc : forall n m p : nat,
  n + (m + p) = (n + m) + p.
Proof.
  intros n m p.
  induction n as [|n'].
-
  simpl.
  reflexivity.
-simpl. 
  rewrite -> IHn'. 
  reflexivity.
Qed.

Lemma sum_helper : forall n : nat,
  2 * sum_to (S n) = 2 * (S n) + 2 * (sum_to n).
Proof. (* 目前，我们还无法证明该引理。我们直接接受它。*) Admitted.

Theorem sum_to_equation : forall n : nat,
  2 * (sum_to n) = n * (n + 1).
Proof. Admitted.

Theorem plus_0_r : forall n : nat, n + 0 = n.
Proof.
  intros n.
  induction n as [|m].
-reflexivity.
- simpl. rewrite -> IHm. reflexivity.
Qed.

Theorem plus_comm : forall n m : nat,
  n + m = m + n.
Proof.
  intros n m.
  induction n as [|n'].
- simpl. rewrite -> plus_0_r. reflexivity.
- simpl. rewrite <- plus_n_Sm. rewrite -> IHn'. reflexivity.
Qed.


Theorem mult_a_Sb' : forall a b : nat,  a * S b = a * b + a.
Proof.
  intros.
  induction a.
  - reflexivity.
  - simpl.
    rewrite IHa.
    rewrite plus_assoc.
    assert (H: forall x y:nat, x + (S y) = S (x+y)).
 {      intros.      rewrite plus_comm.      simpl.      rewrite plus_comm.      reflexivity.    }
    rewrite H.
    reflexivity.
Qed.

Theorem plus_swap : forall n m p : nat,
  n + (m + p) = m + (n + p).
Proof.
  intros n m p.
  rewrite -> plus_comm.
  rewrite <- plus_assoc.
  assert (H : p + n = n + p).
    rewrite -> plus_comm. reflexivity.
  rewrite -> H. reflexivity.
Qed.



Theorem sum_n:forall n: nat,(sum_to n) + (sum_to n) = n * (S n).
Proof.
  induction n.
  - reflexivity.
  - simpl.
    rewrite (mult_a_Sb' n (S n)).
    rewrite plus_assoc.
    rewrite plus_comm.
    simpl.
    rewrite plus_swap.
    rewrite <- plus_assoc.
    rewrite IHn.
    rewrite plus_comm.
    reflexivity.
Qed.

Fixpoint double (n:nat) :=
  match n with
  | O => O
  | S n' => S (S (double n'))
  end.

Theorem xianeryijianhaideizheng:
forall n m, double n = double m -> n = m.
Proof.
  intros n .
 induction n as [ | n' IHn'].
  - (* n = 0 *)
     intros m eq.
     simpl in eq.
    destruct m as [ | m'] eqn:E.
    + (* E : m = 0 *)
      reflexivity.
    + (* E : m = S m' *)
      simpl in eq.
 discriminate eq.
- (* n = S n' *)
    simpl.
 intros m eq.
    destruct m as [ | m'] eqn:E.
    + (* E : m = 0 *)
 simpl in eq. discriminate eq.
    + (* E : m = S m' *)
       apply f_equal.
      apply IHn'.
      simpl in eq.
      injection eq as H.
      apply H.
Qed.

